<?php
/*
Plugin Name: Wordpress Gravatars
Plugin URI: http://bloggs.be/wpmu/gravatar
Description: Makes use of Gravatars, places Gravatars in the comments section. Uses the comment authors email to display their Gravatar. It also gives the user an Author Profile picture, based on his or hers Gravatar
Version: 2.1
Author: Rune Gulbrandsøy
Author URI: http://bloggs.be/wpmu/
*/

/*
Instructions on how to use the MU Gravatars plugin.
Remember to set the default Gravatar to what you want it to be.

Your users can turn the Gravatars off, both for comments, posts and for the Author Profile. They can also decide if they'll have the Gravatar
on the left (default) or the right side of the comments.

If you have any questions, feel free to email me at rune(@)bloggs.be

*/



function gravatar_admin_menu(){
    add_submenu_page('themes.php', 'Gravatar', 'Gravatar', 8, 'gravatar', 'gravatar_admin');
    
}

function show_gravatar($s) {
$gravatar = get_option('bruk_gravatar');
$gravatar_align = get_option('bruk_gravatar_align');
$default = get_option('default_gravatar');
$gravatar_use_url = get_option('bruk_gravatar_url');
	if($gravatar == true){
	global $comment;
if ( !empty( $comment->comment_author_email ) ) {
        $md5 = md5( $comment->comment_author_email );
        //$default == $default_gravatar;
        $comment_name = $comment->comment_author;
        if ( $comment->comment_author_url == 'http://') {
        	$comment_link = get_option('home');
        	}else{
        	$comment_link = $comment->comment_author_url;
        	}
        //edit the style to what you want, the standard style looks good on most themes.
        if($gravatar_align == true){
        	if($gravatar_use_url == true){
       			 $s = "$comment_name<div><a href='$comment_link'><img style='float: right;' src='http://www.gravatar.com/avatar.php?gravatar_id=$md5&amp;size=40&amp;default=$default' alt='' /></a></div>";
       		} else {
       			$s = "$comment_name<div><img style='float: right;' src='http://www.gravatar.com/avatar.php?gravatar_id=$md5&amp;size=40&amp;default=$default' alt='' /></div>";
       		}
		}else{
			if($gravatar_use_url == true){
        		$s = "<a href='$comment_link'><img style='float: left; margin-right: 10px;' src='http://www.gravatar.com/avatar.php?gravatar_id=$md5&amp;size=40&amp;default=$default' alt='' /></a>$comment_name";
			} else {
				$s = "<img style='float: left; margin-right: 10px;' src='http://www.gravatar.com/avatar.php?gravatar_id=$md5&amp;size=40&amp;default=$default' alt='' />$comment_name";
			}
		}}
	return $s;
}
return $s;
}

function show_gravatar_post($s) {
$gravatar = get_option('bruk_gravatar');
$gravatar_align = get_option('bruk_gravatar_align');
$default = get_option('default_gravatar');
$post_gravatar = get_option('bruk_gravatar_post');
//$s = "Dette skal ikke komme";
	if($post_gravatar == true){
	global $post;
       $epost = get_the_author_email();
        $md5 = md5($epost);
        $content=$s;
        $s= "<img style='float: left; margin-right: 10px;' src='http://www.gravatar.com/avatar.php?gravatar_id=$md5&amp;size=20&amp;default=$default' alt=''/>";
		$s=$s."$content";
		}
	return $s;
	
}



function gravatar_admin(){
	$default_gravatar = get_option('default_gravatar');
		if ($default_gravatar != '') {
			$default_gravatar_temp = $default_gravatar;
			}else{
			$default_gravatar_temp = "http://use.perl.org/images/pix.gif";
			}
	$gravatar = get_option('bruk_gravatar');
	$gravatar_align = get_option('bruk_gravatar_align');
	$gravatar_profil = get_option('bruk_gravatar_profil');
	$gravatar_url = get_option('bruk_gravatar_url');
	$version = "2.1";
	
	if ($_POST['updatinggravatar']) {
		$temp_grav = $_POST['defaultgravataroption'];
		
		if ($_POST['bruke_gravatar']) {
			$gravatar = true;
			
		} else {
			$gravatar = false;
			
		}
		
		 if ($_POST['bruke_gravatar_align']){
		 	$gravatar_align = true;
		 	} else {
		 	$gravatar_align = false;
		 	}
		 if ($_POST['bruke_gravatar_profil']){
		 	$gravatar_profil = true;
		 	} else {
		 	$gravatar_profil = false;
		 	}
		 	
		 if ($_POST['bruk_gravatar_post']){
		 	$gravatar_post = true;
		 	} else {
		 	$gravatar_post = false;
		 	}
		 	
		  if ($_POST['bruk_gravatar_url']){
		 	$gravatar_url = true;
		 	} else {
		 	$gravatar_url = false;
		 	}
		 
		 if ($_POST['default_gravatar']){
		 	$default_gravatar = $_POST['default_gravatar'];
		 	}
			
			
			
		 
		update_option('bruk_gravatar', $gravatar);
		update_option('bruk_gravatar_align', $gravatar_align);
		update_option('bruk_gravatar_profil', $gravatar_profil);
		update_option('bruk_gravatar_post', $gravatar_post);
		update_option('bruk_gravatar_url', $gravatar_url);
		update_option('default_gravatar', $default_gravatar);
		
	echo '<div id="message" class="updated fade"><p>Your choices has been updated</p></div>';
	
	}

?>
<div class="wrap">
<h2><?php _e('Gravatars')?></h2>
<p><?php _e('This is where you control your Gravatars. Both in your comments and your <strong>Author Profile</strong> widget.')?></p>

<p><?php _e('If you do not have a Gravatar, you can get your very own over at the <a href="http://site.gravatar.com/signup">Gravatar</a> site')?></p>
<form action="" method="post">
<p><label><input name="bruke_gravatar" value="gravatar" type="checkbox" <?php if ($gravatar) { ?> checked="checked" <?php } ?> /> Use Gravatars on your comments.</label></p>
<p><label><input name="bruke_gravatar_align" value="gravatar_align" type="checkbox" <?php if ($gravatar_align) { ?> checked="checked" <?php } ?> /> Place the Gravatar on the right side of the comments (default is the left side).</label></p>
<p><label><input name="bruke_gravatar_profil" value="gravatar_profil" type="checkbox" <?php if ($gravatar_profil) { ?> checked="checked" <?php } ?> /> Use the <strong>Author Profile</strong> widget (you have to activate the widget from the widget page).</label></p>
<p><label><input name="bruk_gravatar_post" value="gravatar_post" type="checkbox" <?php if ($gravatar_post) { ?> checked="checked" <?php } ?> /> Use your Gravatar with your blog posts. This will always be on the left side, before your content.</label></p>
<p><label><input name="bruk_gravatar_url" value="gravatar_url" type="checkbox" <?php if ($gravatar_url) { ?> checked="checked" <?php } ?> /> Make the Gravatar link back to comment authors blog/url. If no link is given it links to <em><?php echo get_option('home'); ?></em></label></p>
<p><label><?php _e('<input type="text" name="default_gravatar" value="' . $default_gravatar_temp . '" size="50"/>')?><br/>
<?php _e('<small>Current default Gravatar : ' . $default_gravatar_temp . ' <img src="' . $default_gravatar_temp . '" width="30px" height="30px"/></small>')?></label></p>
<p><?php _e('<small>&copy; <a href="http://bloggs.be/wpmu/gravatar/">Rune G</a> You are using version :' . $version . '</small>')?></p>
<p class="submit">
	<input value="Update Gravatars &raquo;" type="submit" />
	<input name="updatinggravatar" value="true" type="hidden" /></p>
</form>
</div>
<?php
}

function widget_authdescription_init() {

	// Check for the required API functions
	if ( !function_exists('register_sidebar_widget') || !function_exists('register_widget_control') )
		return;

	// This saves options and prints the widget's config form.
	function widget_authdescription_control() {
		$options = $newoptions = get_option('widget_authdescription');
		if ( $_POST['authdescription-submit'] ) {
			$newoptions['title'] = strip_tags(stripslashes($_POST['authdescription-title']));
			$newoptions['alignall'] = strip_tags(stripslashes($_POST['authdescription-alignall']));
					$alignall = $newoptions['alignall'];
					if ($alignall == "left")       {$imgalign = 'float:left;margin:5px;';}
					elseif ($alignall == "center") {$imgalign = 'display:block;margin:5px auto 0 auto;';}
					elseif ($alignall == "right")  {$imgalign = 'float:right;margin:5px;';}
					else echo 'Pick alignment again...';
				$newoptions['imgalign'] = $imgalign;
			$newoptions['bordercolor'] = strip_tags(stripslashes($_POST['authdescription2-bordercolor']));
		}
		if ( $options != $newoptions ) {
			$options = $newoptions;
			update_option('widget_authdescription', $options);
		}
		$imgalign = htmlspecialchars($options['imgalign'], ENT_QUOTES);
		$bordercolor = htmlspecialchars($options['bordercolor'], ENT_QUOTES);
	?>
				<div style="text-align:right">
				<label for="authdescription-title" style="line-height:35px;display:block;">Tittel: <input type="text" id="authdescription-title" name="authdescription-title" value="<?php echo htmlspecialchars($options['title']); ?>" /></label>
				<input type="hidden" name="authdescription-submit" id="authdescription-submit" value="1" />
				</div>
	<?php
	}

	// This prints the widget
	function widget_authdescription($args) {
		extract($args);
		$defaults = array('count' => 10, 'username' => 'wordpress');
		$options = (array) get_option('widget_authdescription');
		$bordercolor = $options['bordercolor'];
		foreach ( $defaults as $key => $value )
			if ( !isset($options[$key]) )
				$options[$key] = $defaults[$key];
?>
		<?php echo $before_widget; ?>
	
<h2><?php echo $options['title']?></h2>
			<?php
			
function print_profile() {
	global $wp_query, $blogownerid;
	global $wpdb, $blog_id;
	$blogownerid = $wpdb->get_var("SELECT post_author FROM wp_" . $blog_id . "_posts");
$userdata = get_userdata($blogownerid); 
 if ($userdata->description != '') { 
echo $userdata->description; }
}

function filechecking() {
	global $wp_query, $blogownerid;
	global $wpdb, $blog_id;
	$default = get_option('default_gravatar');
	$blogownerid = $wpdb->get_var("SELECT post_author FROM wp_" . $blog_id . "_posts");
	//$path = "/customers/bloggs.be/bloggs.be/httpd.www/wp-content/avatars"; //edit to your own path
	$epost = $wpdb->get_var("SELECT user_email FROM wp_users WHERE ID=".$blogownerid."");
	$md5 = md5($epost);
	//$default == $default_gravatar;
	$gravatar_profil = get_option('bruk_gravatar_profil');
	if($gravatar_profil == true){
	echo $before_widget . $before_title . $title . $after_title . "<ul>\n";
	echo "<img style='float: left; margin-right: 10px;' src='http://www.gravatar.com/avatar.php?gravatar_id=$md5&amp;size=40&amp;default=$default' alt='' />";
	}
}
?>

<a href="<?php echo get_bloginfo('url')."/about/"?>"><?php filechecking(); ?></a>

		<?php echo print_profile();
		echo "</ul>\n" . $after_widget;	?>
<?php
	}

	// Tell Dynamic Sidebar about our new widget and its control
	register_sidebar_widget('Author Profile', 'widget_authdescription');
	register_widget_control('Author Profile', 'widget_authdescription_control');

}



add_action('admin_menu', 'gravatar_admin_menu');
add_filter('get_comment_author_link', 'show_gravatar');
add_filter('the_content', 'show_gravatar_post',1);
add_action('plugins_loaded', 'widget_authdescription_init');
?>